﻿namespace TabsStudioNoMoreOpen
{
    public class NoMoreOpen : TabsStudioExt.ITabsStudioAddin
    {
        public void OnConnection(TabsStudioExt.ITabsStudioEngine engine, EnvDTE80.DTE2 dte)
        {
            this.engine = engine;

            engine.OpeningTabExtensionContextMenu += OpeningTabExtensionContextMenu;
            engine.OpeningTabContextMenu += OpeningTabContextMenu;
        }

        public void OnDisconnection()
        {
            engine.OpeningTabExtensionContextMenu -= OpeningTabExtensionContextMenu;
            engine.OpeningTabContextMenu -= OpeningTabContextMenu;
        }

        private void OpeningTabExtensionContextMenu(object sender, TabsStudioExt.OpeningTabExtensionContextMenuEventArgs e)
        {
            OpeningContextMenu(e.ContextMenu);
        }

        private void OpeningTabContextMenu(object sender, TabsStudioExt.OpeningTabContextMenuEventArgs e)
        {
            OpeningContextMenu(e.ContextMenu);
        }

        private void OpeningContextMenu(System.Windows.Controls.ContextMenu menu)
        {
            if (CountOpenItems(menu) > 5)
            {
                RemoveItems(menu, "Open");
                RemoveItems(menu, "OpenSeparator");
            }
        }

        private int CountOpenItems(System.Windows.Controls.ContextMenu menu)
        {
            int result = 0;
            foreach (object item in menu.Items)
            {
                if (NameMatch(item, "Open"))
                    ++result;
            }
            return result;
        }

        private void RemoveItems(System.Windows.Controls.ContextMenu menu, string name)
        {
            System.Windows.Controls.Control item = FindItem(menu, name);
            while (item != null)
            {
                menu.Items.Remove(item);
                item = FindItem(menu, name);
            }
        }

        private System.Windows.Controls.Control FindItem(System.Windows.Controls.ContextMenu menu, string name)
        {
            foreach (object item in menu.Items)
            {
                if (NameMatch(item, name))
                    return item as System.Windows.Controls.Control;
            }
            return null;
        }

        private bool NameMatch(object item, string name)
        {
            if (item is System.Windows.Controls.Control)
            {
                if ((item as System.Windows.Controls.Control).Name.Equals(name))
                    return true;
            }
            return false;
        }

        private TabsStudioExt.ITabsStudioEngine engine;
    }
}
